SystemOrganization addCategory: #HarryPotter!
SystemOrganization addCategory: 'HarryPotter-Tests'!

TestCase subclass: #EscuelaTest
	instanceVariableNames: 'harryPotter ron draco gryffindor slytherin hufflepuff ravenclaw hogwarts sombreroSombrerito'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HarryPotter-Tests'!

EscuelaTest class
	instanceVariableNames: 'sombreroSombrerito'!

!EscuelaTest commentStamp: '<historical>' prior: 0!
An EscuelaTest is a test class for testing the behavior of Escuela!

EscuelaTest class
	instanceVariableNames: 'sombreroSombrerito'!

!EscuelaTest methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/6/2014 19:20'!
setUp
harryPotter := Mago new.
harryPotter colorPelo: 'marron'.
harryPotter inteligencia: 110.
harryPotter sangreSucia: true.
harryPotter inicializarEnemigos.
harryPotter inicializarLosQueSigo.

ron := Mago new.
ron colorPelo: 'rojo'.
ron inteligencia: 90.
ron sangreSucia: false.
ron inicializarEnemigos.
ron inicializarLosQueSigo.

draco := Mago new.
draco colorPelo: 'amarillo'.
draco inteligencia: 105.
draco sangreSucia: false.
draco inicializarEnemigos.
draco inicializarLosQueSigo.

gryffindor := Gryffindor new.
gryffindor inicializar.

slytherin := Slytherin new.
slytherin inicializar.

ravenclaw := Ravenclaw new.
ravenclaw inicializar.

hufflepuff := Hufflepuff new. 
hufflepuff inicializar.

sombreroSombrerito := Sombrero new.
sombreroSombrerito crearCasas.
sombreroSombrerito agregarCasas: gryffindor.
sombreroSombrerito agregarCasas: slytherin.
sombreroSombrerito agregarCasas: ravenclaw.
sombreroSombrerito agregarCasas: hufflepuff.

hogwarts := Escuela new.
hogwarts inicializar.
hogwarts agregarCasa: gryffindor.
hogwarts agregarCasa: slytherin.
hogwarts agregarCasa: ravenclaw.
hogwarts agregarCasa: hufflepuff.
hogwarts sombreroSeleccionador: sombreroSombrerito.! !

!EscuelaTest methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/6/2014 19:58'!
testPreguntarAlSombreroAQueCasaEntraHarryPotter

(hogwarts sombreroSeleccionador) seleccionarCasa: harryPotter.! !

Object subclass: #Escuela
	instanceVariableNames: 'casas sombreroSeleccionador'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HarryPotter'!

!Escuela methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/7/2014 02:04'!
aQueCasaLeCorrespondeIr: unMago
^sombreroSeleccionador seleccionarCasa: unMago.! !

!Escuela methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/6/2014 01:56'!
agregarCasa: unaCasa
casas add: unaCasa.! !

!Escuela methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/6/2014 02:03'!
cuantosSiguenA: unMago
casas sum:[:casa | casa cuantosSiguenA: unMago]! !

!Escuela methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/7/2014 02:30'!
elMago: magoSeguidor puedeSeguirA: magoSeguido
^( magoSeguidor  puedoSeguirA: magoSeguido).! !

!Escuela methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/7/2014 02:34'!
elMago: magoSeguidor vaASeguirA: magoSeguido 
magoSeguidor seguisA: magoSeguido.! !

!Escuela methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/7/2014 02:31'!
esta: unMago enLaMismaEscuelaQue: otroMago
^(casas detect:[:casa | ( (casa estaAca: unMago) & (casa estaAca: otroMago) )]
ifNone: 'No estan en la misma casa').! !

!Escuela methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/6/2014 01:55'!
inicializar 
casas := Set new.! !

!Escuela methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/7/2014 02:07'!
queCasaTieneMasMagos
casas detectMax:[:casa | casa cantidadDeMagos ].! !

!Escuela methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/6/2014 19:09'!
sombreroSeleccionador
^sombreroSeleccionador.! !

!Escuela methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/6/2014 19:09'!
sombreroSeleccionador: sombrero
sombreroSeleccionador := sombrero.! !

Object subclass: #Gryffindor
	instanceVariableNames: 'magos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HarryPotter'!

!Gryffindor methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/7/2014 00:41'!
aceptaA: unMago
^(unMago esPelirrojo & unMago inteligenciaPromedio).! !

!Gryffindor methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/6/2014 00:25'!
agregarMago: unMago
(self aceptaA: unMago) ifTrue:[magos add: unMago].! !

!Gryffindor methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/7/2014 02:07'!
cantidadDeMagos
magos size.! !

!Gryffindor methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/6/2014 02:08'!
cuantosSiguenA: unMago
^(magos collect:[:mago | mago seguisA: unMago]) size.! !

!Gryffindor methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/7/2014 02:21'!
estaAca: unMago
magos includes: unMago.! !

!Gryffindor methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/6/2014 00:23'!
inicializar
magos := Set new.! !

Object subclass: #Hufflepuff
	instanceVariableNames: 'magos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HarryPotter'!

!Hufflepuff methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/5/2014 22:55'!
aceptaA: unMago
^true.! !

!Hufflepuff methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/6/2014 00:25'!
agregarMago: unMago
(self aceptaA: unMago) ifTrue:[magos add: unMago].! !

!Hufflepuff methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/7/2014 02:07'!
cantidadDeMagos
magos size.! !

!Hufflepuff methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/6/2014 02:13'!
cuantosSiguenA: unMago
^(magos collect:[:mago | mago seguisA: unMago]) size.! !

!Hufflepuff methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/7/2014 02:21'!
estaAca: unMago
magos includes: unMago.! !

!Hufflepuff methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/6/2014 00:23'!
inicializar
magos := Set new.! !

Object subclass: #Mago
	instanceVariableNames: 'colorPelo inteligencia sangreSucia enemigos padre escuela losQueSigo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HarryPotter'!

!Mago methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/6/2014 02:13'!
agregarAQuienSigo: unMago
losQueSigo add: unMago.! !

!Mago methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/5/2014 23:31'!
agregarEnemigo:unMago
enemigos add: unMago.! !

!Mago methodsFor: 'as yet unclassified' stamp: 'Juan 9/30/2014 10:01'!
colorPelo
^colorPelo! !

!Mago methodsFor: 'as yet unclassified' stamp: 'Juan 9/30/2014 10:01'!
colorPelo: color
colorPelo := color! !

!Mago methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/6/2014 01:46'!
esEnemigoDe: unMago
^(enemigos includes: unMago).! !

!Mago methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/5/2014 23:47'!
esHermanoDe: unMago
^( (padre = unMago miPadreEs) & (self ~= unMago) ).! !

!Mago methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/6/2014 18:39'!
esPelirrojo
^self colorPelo = 'rojo'! !

!Mago methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/6/2014 01:57'!
escuela
^escuela.! !

!Mago methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/6/2014 01:56'!
escuela: unaEscuela
escuela:=unaEscuela.! !

!Mago methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/5/2014 23:31'!
inicializarEnemigos
enemigos := Set new.! !

!Mago methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/6/2014 02:12'!
inicializarLosQueSigo
losQueSigo := Set new.! !

!Mago methodsFor: 'as yet unclassified' stamp: 'Juan 9/30/2014 10:09'!
inteligencia
^inteligencia! !

!Mago methodsFor: 'as yet unclassified' stamp: 'Juan 9/30/2014 10:04'!
inteligencia: numero
inteligencia := numero! !

!Mago methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/7/2014 00:40'!
inteligenciaPromedio
^(self inteligencia >80) & (self inteligencia <120)! !

!Mago methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/5/2014 23:43'!
miPadreEs 
^padre.! !

!Mago methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/6/2014 00:40'!
muyInteligente
^(self inteligencia) >= 120! !

!Mago methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/6/2014 01:58'!
puedoSeguirA: unMago
^(
	(self esEnemigoDe: unMago not) & 
	( 
		(self esHermanoDe: unMago) | 
		( 
			unMago inteligencia > self inteligencia | 
			self escuela cuantosSiguenA: unMago >3
		) 
	) 
).! !

!Mago methodsFor: 'as yet unclassified' stamp: 'Juan 9/30/2014 10:22'!
sangreSucia
^sangreSucia! !

!Mago methodsFor: 'as yet unclassified' stamp: 'Juan 9/30/2014 10:12'!
sangreSucia: valor
sangreSucia := valor! !

!Mago methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/7/2014 02:34'!
seguisA: unMago
losQueSigo includes: unMago.! !

Object subclass: #Ravenclaw
	instanceVariableNames: 'magos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HarryPotter'!

!Ravenclaw methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/6/2014 18:40'!
aceptaA: unMago
^(unMago muyInteligente).! !

!Ravenclaw methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/6/2014 00:26'!
agregarMago: unMago
(self aceptaA: unMago) ifTrue:[magos add: unMago].! !

!Ravenclaw methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/7/2014 02:07'!
cantidadDeMagos
magos size.! !

!Ravenclaw methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/6/2014 02:13'!
cuantosSiguenA: unMago
^(magos collect:[:mago | mago seguisA: unMago]) size.! !

!Ravenclaw methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/7/2014 02:21'!
estaAca: unMago
magos includes: unMago.! !

!Ravenclaw methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/6/2014 00:23'!
inicializar
magos := Set new.! !

Object subclass: #Slytherin
	instanceVariableNames: 'magos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HarryPotter'!

!Slytherin methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/7/2014 00:43'!
aceptaA: unMago
^(unMago sangreSucia) not! !

!Slytherin methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/6/2014 00:27'!
agregarMago: unMago
(self aceptaA: unMago) ifTrue:[magos add: unMago].! !

!Slytherin methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/7/2014 02:07'!
cantidadDeMagos
magos size.! !

!Slytherin methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/6/2014 02:14'!
cuantosSiguenA: unMago
^(magos collect:[:mago | mago seguisA: unMago]) size.! !

!Slytherin methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/7/2014 02:21'!
estaAca: unMago
magos includes: unMago.! !

!Slytherin methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/6/2014 00:23'!
inicializar
magos := Set new.! !

Object subclass: #Sombrero
	instanceVariableNames: 'casas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HarryPotter'!

!Sombrero methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/6/2014 19:11'!
agregarCasas: casa
casas add: casa.! !

!Sombrero methodsFor: 'as yet unclassified' stamp: 'Juan 9/30/2014 11:10'!
crearCasas
casas := OrderedCollection new.! !

!Sombrero methodsFor: 'as yet unclassified' stamp: 'Juan 9/30/2014 11:11'!
seleccionarCasa: mago 
^casas detect: [ :casa | casa puedeEntrar: mago ]! !
